var d = document;
function g(o) {return d.getElementById(o);}
function s(o) {g(o).style.visibility = 'visible';}
function h(o) {g(o).style.visibility = 'hidden';}
function m(o, x, y) {
	g(o).style.left = x+'px';
	g(o).style.top = y+'px';
	}
	
function itemPosition(o) {
	var item = g(o);
	var coords = {x: 0, y: 0 };
	while(item && item != g('crumbContainer')) {
		coords.x += item.offsetLeft;
		coords.y += item.offsetTop;
		item = item.offsetParent;
		}
	return coords;
	}

function menuOver(id) {
	s('menu'+id);
	s('menu'+id+'back');

	showNavTree(id);
 	}

function menuOut(id) {
	hideMenu(id);

	setTimeout('checkMenus()',64); 	
	}

function hideMenu(id) {
	h('menu'+id);
	h('menu'+id+'back');
	}

function menuBackOver(id) {
	if(id > 0) {
		if(tempNavTree[id-1] != '') {
			//s('menu'+(id-1));
			menuOver(id-1)
			}
		else {
			crumbOver(id-1);
			}
		}
	h('menu'+id+'back');
	}

function itemOver(o) {
	o.style.backgroundColor = menuItemBgOver;
	}
function itemOut(o) {
	o.style.backgroundColor = menuItemBgOut;
	}

function readCrumbs(crumbName) {
	var crumb = eval('cm_'+crumbName);
	for(var i = 0; i < crumb.length; i++) {
		if(crumb[i][2] != 0) {
			crumb[i][3] = readCrumbs(crumbName+'_'+crumb[i][2]);
			}
		}
	return crumb;
	}

function findDepth(crumb, startDepth) {
	var depth = 0;
	var maxDepth = 0;
	for(var i = 0; i < crumb.length; i++) {
		if(crumb[i][2] != 0) {
			depth = findDepth(crumb[i][3], startDepth+1);
			}
		maxDepth = (depth > maxDepth) ? depth : maxDepth;
		}
	return (maxDepth != 0) ? maxDepth : startDepth;
	}

function resetNavTree() {
	for(var i = 0; i < crumbDepth; i++) {
		tempNavTree[i] = '';
		h('menu'+i);
		h('menu'+i+'back');
		}
	h('navTree');
	}

function showNavTree(id) {
	var coords = itemPosition('crumb0');
	var output = '';
	
	for(var i = 0; i < crumbDepth; i++) {
		if(i < id) {
			output += '<div class="navTree" style="width:'+crumbWidth+'px; height:'+crumbHeight+'px">';	
			output += '<table cellpadding="0" cellspacing="0" border="0" width="100%"><tr><td width="*">&nbsp;';
			if(tempNavTree[i] && tempNavTree[i] != currentLocation[i])
				output += '<i>'+tempNavTree[i]+'</i>'
			else
				output += '<b>'+currentLocation[i]+'</b>';
			output += '</td><td align="right" width="12" valign="top">';
			output += rightSep;
			output += '</td></tr></table>';
			output += '</div>';
			}
		else {
			output += '<div class="navTree" style="width:'+crumbWidth+'px; height:'+crumbHeight+'px">&nbsp;</div>';	
			}
		}
	
	g('navTree').innerHTML = output;
	s('navTree');
	m('navTree',coords.x, coords.y);
	}

function checkMenus() {
	menusVisible = 0;
	for(var i = 0; i < crumbDepth; i++) {
		if(g('menu'+i).style.visibility == 'visible') {
			menusVisible++;
			}
		}
	if(menusVisible <= 0) {
		resetNavTree();
		}
	}

function writeTree(crumb, depth) {	
	for(var i = 0; i < crumb.length; i++) {
		var t = ''
		for(var u = 0; u < depth; u++) {t += '&nbsp;&nbsp;';}
		document.write(t+crumb[i][0]+'<br />');
		if(crumb[i][2] != 0) {
			writeCrumbs(crumb[i][3], depth+1);
			}
		}
	return crumb;
	}

function crumbItem(crumb, id, overCmd) {
	var output = '';
	var crumbClass = 'menuItem';
	var linkText = '';
	if(crumb[1]) {
		crumbClass = 'menuItemLink';
		linkText = 'onclick="window.location.href=\''+crumb[1]+'\'"';
		}
	if(crumb[2]) {
		output += '<div '+linkText+' onmouseout="itemOut(this); hideMenu('+(id+1)+');" onmouseover="itemOver(this); tempNavTree['+id+'] = \''+crumb[0]+'\'; '+overCmd+'" class="'+crumbClass+'" style="width:'+(crumbWidth)+'px; height:'+crumbHeight+'px;">';
		}
	else {output += '<div '+linkText+' onmouseout="itemOut(this);" onmouseover="itemOver(this); tempNavTree['+id+'] = \''+crumb[0]+'\';" class="'+crumbClass+'" style="width:'+(crumbWidth)+'px; height:'+crumbHeight+'px;">';}
	output += '<table cellpadding="0" cellspacing="0" border="0" width="100%"><tr><td width="*">&nbsp;';
	output += (crumb[0] == currentLocation[id]) ? '<b>'+crumb[0]+'</b>' : crumb[0];
	output += '</td><td align="right" width="12" valign="top">';
	output += (crumb[2]) ? rightSep : noSep;
	output += '</td></tr></table>';
	output += '</div>';
	
	return output;
	}

function crumbOver(id) {
	resetNavTree(); // reset the temporary trail;
	var coords = itemPosition('crumb'+id);
	var output = '';
	var crumb = eval(crumbDefaults[id]);
	
	for(var i = 0; i < crumb.length; i++) {	
		output += crumbItem(crumb[i], id, 'nextMenu('+(id+1)+', \''+crumbDefaults[id]+'_'+crumb[i][2]+'\');');
		}

	g('menu'+id).style.height = crumb.length*crumbHeight+'px';
	g('menu'+id).innerHTML = output;
	m('menu'+id, coords.x, coords.y);
	s('menu'+id);
	
	// set up 'backmenu'
	g('menu'+id+'back').style.height = crumb.length*crumbHeight+'px';
	m('menu'+id+'back', (coords.x - backOverWidth), coords.y);
	s('menu'+id+'back');
	}

function nextMenu(id, crumbName) {
	var crumb = eval(crumbName);
	var coords = itemPosition('crumb'+id);
	var output = '';

	for(var i = 0; i < crumb.length; i++) {
		output += crumbItem(crumb[i], id, 'nextMenu('+(id+1)+', \''+crumbName+'_'+crumb[i][2]+'\');');
		}
	
	g('menu'+id).style.height = crumb.length*crumbHeight+'px';
	g('menu'+id).innerHTML = output;
	m('menu'+id, coords.x, coords.y);
	
	var newHeight = parseInt(g('menu'+(id-1)).offsetHeight);
	if(crumb.length*crumbHeight < newHeight) {g('menu'+id).style.height = newHeight+'px';}
	s('menu'+id);
	
	// set up 'backmenu'
	g('menu'+id+'back').style.height = parseInt(g('menu'+id).offsetHeight)+'px';
	m('menu'+id+'back', (coords.x - backOverWidth), coords.y);
	s('menu'+id+'back');
	}

// worker global variables
var isNavigating = false;

var crumbRoot = readCrumbs('root');
var crumbDepth = findDepth(crumbRoot,1);

var menusVisible = 0;
var backOverWidth = parseInt(crumbWidth/5);

var rightSep = '<img src="i/sep.gif" width="12" vspace="5" height="5" />';
var noSep = '<img src="i/s.gif" width="12" vspace="5" height="5"  />';

// create breadcrumbs

var crumbDefaults = new Array();
var tempNavTree = new Array();
var menuContent = new Array();

var output = '';
var arrayName = 'cm_root';
output += '<div id="crumbContainer" style="position:relative; top:0px; left:0px; width:'+(crumbDepth*crumbWidth)+'px">';
output += '<div id="navTree" class="navTreeBar" style="position:absolute; left:0px; top:0px; width:'+(crumbDepth*crumbWidth)+'px; height:'+crumbHeight+'px;"></div>';

for(var i = 0; i < crumbDepth; i++) {
	if(i < currentLocation.length) {
		var crumb = eval(arrayName);
		crumbDefaults[i] = arrayName;
		for(var u = 0; u < crumb.length; u++) {
			if(crumb[u][0] == currentLocation[i]) {
				arrayName = arrayName+'_'+crumb[u][2];
				}
			}
		output += '<div id="crumb'+i+'" class="crumb" style="width:'+crumbWidth+'px; height:'+crumbHeight+'px" onmouseover="crumbOver('+i+');">';
		output += '<table cellpadding="0" cellspacing="0" border="0" width="100%"><tr><td width="*">';
		output += '&nbsp;<b>'+currentLocation[i]+'</b>';
		output += '</td><td align="right" width="12" valign="top">';
		output += (i < currentLocation.length - 1) ? rightSep : noSep;
		output += '</td></tr></table>';
		output += '</div>';
		}
	else {
		output += '<div id="crumb'+i+'" class="crumb" style="width:'+crumbWidth+'px"></div>';
		}
	output += '<div id="menu'+i+'" onmouseover="menuOver('+i+');" onmouseout="menuOut('+i+');" class="crumbMenu" style="width:'+crumbWidth+'px"></div>';
	output += '<img id="menu'+i+'back" class="menuBack" onmouseover="menuBackOver('+i+');" src="i/s.gif" style="width:'+backOverWidth+'px;" />';
	}

output += '</div>';
document.write(output);

resetNavTree();